function I = romberg( f, a, b, n )
ncells = 1 ;  h = b - a; 
x = [ a, b ]; 
T(1) = h * sum( feval( f, x ) ) / 2; 
for i = 1 : n
  ncells = 2 * ncells ;  h = h / 2;            
  xc = ( x(1:end-1) + x(2:end) ) / 2;  
  T(i+1) = T(i) / 2 + h * sum( feval(f,xc) );  
  npts = ncells + 1;
  x(1:2:npts  ) = x;                           
  x(2:2:npts-1) = xc; 
end
[ Textrap, T, E, R ] = extrap( T ); 
I = Textrap;                          
fprintf( 1, '\n' )                              
fprintf( 1, 'T-table \n' )
fprintf( 1, '------- \n' )
for i = 1 : size(T,1)
  fprintf( 1, ' %18.15f %18.15f %18.15f %18.15f %18.15f %18.15f ', T(i,1:i) )
  fprintf( 1, '\n' )
end
fprintf( 1, '\n' )
fprintf( 1, 'E-table \n' )                      
fprintf( 1, '------- \n' )
for i = 1 : size(E,1)
  fprintf( 1, ' %18.15f %18.15f %18.15f %18.15f %18.15f ', E(i,1:i) )
  fprintf( 1, '\n' )
end
function [ Textrap, T, E, R ] = extrap( Tvec )
I = length( Tvec );
T = zeros(I,I); 
E = zeros(I-1,I-1);  
R = zeros(I-2,I-2); 
T(:,1) = Tvec(:); 
for j = 1 : I-1 
  i = j : I-1 ;
  E(i,j) = ( T(i+1,j) - T(i,j) ) / ( 4^j - 1 ); 
  T(i+1,j+1) = T(i+1,j) + E(i,j); 
end
 
Textrap = T(I,I);
for j = 1 : I-2
  i = j : I-2 ;
  R(i,j) = E(i,j) ./ E(i+1,j);
end
